/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.blurryroots.yanecos.exception;

import com.blurryroots.yanecos.core.Data;


/**
 * Base class for exceptions with information about
 * the entity and the data causing the exception.
 * 
 * @author Sven Freiberg
 */
public class EntityDataException extends YanecosException {
    /**
	 * Serialization stuff.
	 */
	private static final long serialVersionUID = 1L;
	
	/**
	 * Stores the type of data causing the exception.
	 */
    private Class<? extends Data> _dataType;
    /**
     * Stores the id of the entity causing the exception.
     */
    private long _entityId;

    /**
     * Builds an EntityDataException.
     * @param someMsg An exception message.
     * @param someDataType Type of data.
     * @param someEntityId Entity id.
     */
    public EntityDataException(
            String someMsg,
            Class<? extends Data> someDataType,
            long someEntityId ) {
        //
        super( someMsg );

        //
        _dataType = someDataType;
        _entityId = someEntityId;
    }

    /**
     * Getter
     * @return classtype of data
     */
    public Class<? extends Data> getDataType() {
        //
        return _dataType;
    }

    /**
     * Getter
     * @return entity id
     */
    public long getEntityId() {
        //
        return _entityId;
    }

}
